/*
   Source for x86 emulator IdaPro plugin
   File: emufuncs.h
   Copyright (c) 2004, Chris Eagle
   
   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2 of the License, or (at your option) 
   any later version.
   
   This program is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
   FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
   more details.
   
   You should have received a copy of the GNU General Public License along with 
   this program; if not, write to the Free Software Foundation, Inc., 59 Temple 
   Place, Suite 330, Boston, MA 02111-1307 USA
*/

#ifndef __EMULATE_FUNCS_H
#define __EMULATE_FUNCS_H

#include "hooklist.h"

class MemoryManager;

void emu_VirtualAlloc(MemoryManager *mgr, unsigned int addr = 0);
void emu_VirtualFree(MemoryManager *mgr, unsigned int addr = 0);
void emu_GetProcAddress(MemoryManager *mgr, unsigned int addr = 0);
void emu_GetModuleHandle(MemoryManager *mgr, unsigned int addr = 0);
void emu_LoadLibrary(MemoryManager *mgr, unsigned int addr = 0);

void emu_malloc(MemoryManager *mgr, unsigned int addr = 0);
void emu_calloc(MemoryManager *mgr, unsigned int addr = 0);
void emu_realloc(MemoryManager *mgr, unsigned int addr = 0);
void emu_free(MemoryManager *mgr, unsigned int addr = 0);

void makeImportLabel(dword addr);

/*
 * These are used to setup hooking dialog menu entries
 */
typedef struct _HookEntry_t {
   char *fName;
   hookfunc func;
} HookEntry;

extern HookEntry hookTable[];

#endif